#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

import abc

from bu4.evaluation.constructs.evaluable import Evaluable

__all__ = ('EValue',)


class EValue(Evaluable, abc.ABC):
    def next(self) -> 'EValue':
        return self

    def call(self, argument: Evaluable) -> Evaluable:
        raise NotImplementedError
