#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.linking.states.afterlinking import AfterLinking
from bu4.linking.states.linkingstate import LinkingState
from bu4.linking.targets.altarget import ALTarget
from bu4.parsing.constructs.linked import Linked

__all__ = ('ALChain',)


class ALChain(ALTarget):
    def __init__(self, target: ALTarget, aftertarget: ALTarget):
        self.target = target
        self.aftertarget = aftertarget

    def given(self, linked: Linked) -> LinkingState:
        return AfterLinking(self.target.given(linked), self.aftertarget)
